#! /usr/bin/env python

from utils import *
from cp_elf import get_cps_elf, get_connectivity
import numpy as np
import sys
import os
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D


critout_fname = sys.argv[1]
os.system("./read_cro.sh " + critout_fname + " >/dev/null ")
fn_common = os.path.splitext(critout_fname)[0]

# Gather attractors
crit_attr = np.loadtxt(fn_common + "-attr.dat")
attr_pos = crit_attr[:, 2:5]
n_at = len(crit_attr)


# Gather bond saddle points
crit_bond, cps_elf = get_cps_elf(fn_common)
idx_saddle_sort = np.argsort(-np.unique(cps_elf[:, -1]))
elf_saddle = np.unique(cps_elf[:, -1])[idx_saddle_sort]
# print(elf_saddle)


# Iterate over decreasing ELF values in saddle points
for elf_val in elf_saddle:
    print("ELF value saddle pt: {}".format(elf_val))
    connect = get_connectivity(elf_val, crit_attr, cps_elf, crit_bond)

    ineq_grp, sep_connect = get_separate(connect)

    if np.any(connect):
        if is_3D(attr_pos, connect):
            if len(sep_connect) != 1:
                is_3D_grp = []
                for p, grp_conn in enumerate(sep_connect):
                    sep_attr = attr_pos[ineq_grp[p], :]
                    is_3D_grp.append(is_3D(sep_attr, grp_conn))
                if any(is_3D_grp):
                    print("Neworking value: {}".format(elf_val))
                    plot_connect(
                        "{}-saddle-{:.4}.png".format(fn_common, elf_val), attr_pos, connect
                    )
                    break
            else:
                print("Neworking value: {}".format(elf_val))
                plot_connect("{}-saddle-{:.4}.png".format(fn_common, elf_val), attr_pos, connect)
                print("")
                break
    print("")
