#! /bin/bash


cro_file=$1
cro_file_prefix=${cro_file%.*}
echo $cro_file

ncrit=$(grep "+ Critical point no." $cro_file | wc -l)
linecrit=$(grep -n "* Critical point list, final report" $cro_file | awk '{print $1}')
linecrit=${linecrit:0:-2}

linecritinit=$(echo $linecrit+2 | bc)
linecritend=$(echo $linecrit+$ncrit | bc)

awk -v s="$linecritinit" -v e="$linecritend"  'NR>s&&NR<e' $cro_file | grep "(3,-1)" | awk '{print $1, $5, $6, $7, $10}' | tee $cro_file_prefix"-saddle-eq.dat"

ncp_h=$(awk -v s="$linecritinit" -v e="$linecritend"  'NR>s&&NR<e' $cro_file | grep "H_" | awk '{print $1}')

latt_par_x=$(grep "Lattice parameters (bohr):" $cro_file | awk '{print $4}')
latt_par_y=$(grep "Lattice parameters (bohr):" $cro_file | awk '{print $5}')
latt_par_z=$(grep "Lattice parameters (bohr):" $cro_file | awk '{print $6}')



linecritconn1=$(grep -n "* Complete CP list, bcp and rcp connectivity table" $cro_file | awk '{print $1}')
linecritconn2=$(grep -n "* Attractor connectivity matrix" $cro_file | awk '{print $1}')
linecritconn1=${linecritconn1:0:-2}
linecritconn2=${linecritconn2:0:-2}
linecritconn1=$(echo $linecritconn1+2 | bc)
linecritconn2=$(echo $linecritconn2-1 | bc)


awk -v s="$linecritconn1" -v e="$linecritconn2"  'NR>s&&NR<e' $cro_file | grep "n" | awk -v lpx="$latt_par_x" -v lpy="$latt_par_y" -v lpz="$latt_par_z" '{
print $1, $2, $4*lpx, $5*lpy, $6*lpz}' | tee $cro_file_prefix"-attr.dat"


awk -v s="$linecritconn1" -v e="$linecritconn2"  'NR>s&&NR<e' $cro_file | grep "b" | awk -v lpx="$latt_par_x" -v lpy="$latt_par_y" -v lpz="$latt_par_z" '{
if ($13 ~ /^[0-9]*$/)
   print $1, $2, $4*lpx, $5*lpy, $6*lpz, $7, $13;
else
      print $1, $2, $4*lpx, $5*lpy, $6*lpz, $7, $12;	
}' | tee $cro_file_prefix"-bond.dat"

